#!/usr/bin/perl

###############################################################################
# YaBM.pl - Yet another BoardMod                                              #
###############################################################################
#  (C) 2003 Evgueny Galashin                                                  #
#  mailto:zmeigorin@yandex.ru                                                 #
#                                                                             #
#  This program is free software; you can redistribute it and/or modify       #
#  it under the terms of the GNU General Public License as published by       #
#  the Free Software Foundation; either version 2 of the License, or          #
#  (at your option) any later version.                                        #
#                                                                             #
#  This program is distributed in the hope that it will be useful,            #
#  but WITHOUT ANY WARRANTY; without even the implied warranty of             #
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              #
#  GNU General Public License for more details.                               #
#                                                                             #
#  You should have received a copy of the GNU General Public License          #
#  along with this program; if not, write to the Free Software                #
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA    #
#                                                                             #
###############################################################################
 
$boardmodprefix='YaBB 1 Gold - SP 1.3';

$yabbdir='..'; #standalone only

###############################################################################
# if something is wrong with an .lng
if (!$yabmtxt{'1'}){
$yabmtxt{'1'}="Mod list";                                           
$yabmtxt{'2'}="Click on the filename to view details and install mod.";
$yabmtxt{'5'}="Not installed";
$yabmtxt{'6'}="Apply Mod";
$yabmtxt{'7'}="Installed";
$yabmtxt{'8'}="Uninstall Mod";
$yabmtxt{'9'}="Mod Info";#page title
$yabmtxt{'10'}="ID";
$yabmtxt{'11'}="Status";
$yabmtxt{'12'}="Version";
$yabmtxt{'13'}="Author";
$yabmtxt{'14'}="Homepage";
$yabmtxt{'15'}="Mod Info";#tag name
$yabmtxt{'16'}="Back";
$yabmtxt{'17'}="Processing mod";
$yabmtxt{'18'}="Error";
$yabmtxt{'19'}="Add/Remove mods";
}
###############################################################################
# Some stuff for "standalone" version 
if(!$YaBBversion){

eval q`
  chdir $yabbdir if $yabbdir;
  require "Settings.pl";    
  require "$language";
  use CGI qw(standard);  
  
  sub readform {
	my(@pairs, $pair, $name, $value);
	my $query = new CGI;
	if($ENV{QUERY_STRING} =~ m~;~) { @pairs = split(/;/, $ENV{QUERY_STRING}); }
	else { @pairs = split(/&/, $ENV{QUERY_STRING}); }
	foreach $pair (@pairs) {
		  ($name,$value) = split(/=/, $pair);
		  $name =~ tr/+/ /;
		  $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		  $value =~ tr/+/ /;
		  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		  $value =~ s/<!--(.|\n)*-->//g;
		  $INFO{$name} = $value;
	}
	my (@keylist) = sort($query->param());
	foreach $key (@keylist) {
		$postsize += length($query->param($key));
		# may be dealing with multiple values; need to join with comma
		$value = join(', ', $query->param($key));
		$FORM{$key} = $value;
	}
	$action = $INFO{'action'};
  }

  sub fatal_error {
	my $e = $_[0];
	$yymain = qq~
<BR><font size=2>$e</font><BR><BR>
~;
	$yytitle = "Fatal Error!";
	&template;
	exit;

  }

  sub is_admin{

  }

  sub fopen ($$;$) {
	my( $filehandle, $filename, $usetmp ) = @_;
	return  CORE::open($filehandle, $filename);
  }

  sub fclose ($) {
	my $filehandle = $_[0];
	CORE::close($filehandle);
	return 1;
  }
                      
  sub template{
 print "Content-Type: text/html; charset=$yycharset\n\n";
  print qq~
<html>
<head><title>$yytitle</title></head>
<body><font face="Verdana,Arial,sans-serif">
$yymain</font>
</body>
</html>
  ~;
  }

  sub ToHTML {
	$_[0] =~ s/&/&amp;/g;
	$_[0] =~ s/"/&quot;/g;
	$_[0] =~ s/  / \&nbsp;/g;
	$_[0] =~ s/</&lt;/g;
	$_[0] =~ s/>/&gt;/g;
	$_[0] =~ s/\|/\&#124;/g;
  }
  $INFO{'file'}='YaBM.mod';
  $INFO{'action'}='modlist';
  &readform;
  if ($action eq 'uninstallmod'){&applymod;exit;}
  &$action;
`; 

}
# Cut
###############################################################################

####index
sub modlist {
  &is_admin;
  opendir(DIR, "$boarddir/Mods") || &fatal_error( "$txt{'230'} ($boarddir/Mods) :: $!");
  @contents = readdir(DIR);
  closedir(DIR);
  if(fopen(FILE,"$boarddir/install.log")){
    @mods=<FILE>;
    fclose(FILE);
    for(my $i=0;$i<@mods;$i++){
      $mods[$i]=~s#\A[^\\/]+[\\/]##;
    }
    chomp @mods;
  }
  $yymain=qq~     
  <table border=0 width="600" cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" cellpadding="4" align="center">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}">
    <font size=2 class="text1" color="$color{'titletext'}"><b>$yabmtxt{'1'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}">
    <BR><font size="1">$yabmtxt{'2'}</font><BR><BR></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2>
    <BR>~;

  foreach $line (@contents){
    if ($line=~m/.mod\Z/){
      if (linepos(\@mods,$line)!=-1){
        $status="<font face='Wingdings' style='text-decoration:none'>&#254;</font>";
      }else{
        $status="<font face='Wingdings' style='text-decoration:none'>&#168;</font>";
      }
      $yymain.=qq~<a href="$scripturl?action=modinfo;file=$line">$status$line</a><br>
      ~;
    }
  }  
  $yymain.=qq~
  <br></font></td>
  </tr>
</table>~;
  $yytitle = "$yabmtxt{'1'}";
  &template;
  exit;
}
####info
sub modinfo{
  &is_admin;
  my $file=$INFO{'file'};

  my @params=('id','version','mod info','author','homepage');
  $status=$yabmtxt{'5'};$link=qq~<a href="$scripturl?action=applymod;file=$file">$yabmtxt{'6'}</a>~;
  if(fopen(FILE,"$boarddir/install.log")){
    @mods=<FILE>;
    fclose(FILE);
    foreach(@mods){
      s/\A$boardmodprefix\\//;
      chomp;
      if($_ eq $file){$status="$yabmtxt{'7'}";$link=qq~<a href="$scripturl?action=uninstallmod;file=$file">$yabmtxt{'8'}</a>~;last;}
    }
  }

  fopen(FILE, "$boarddir/Mods/$file")||&fatal_error("$txt{'23'} Mods/$file :: $!");
  while(<FILE>){
    if (!$par){
      if($_=~m/\A<([^>]*)/){
        foreach(@params){
          if($_ eq $1) {
            $tag=$1;
            ($par)=split(" ",$tag);
            last;
          }
        }
        next;
      }
    }
  
    if($_=~m/\A<\/([^>]*)>/ && $1 eq $tag){
      undef $par;
      next;
    }
    if ($par){
      &ToHTML($_);
      ${"mod$par"}.=$_;
      $modmod.="<br>" if $par eq "mod"
    }
  }      
  fclose(FILE);
  
  $yymain= qq~
<table border=0 width="98%" cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" cellpadding="4" align="center">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}">
    <font size=2 class="text1" color="$color{'titletext'}"><b>$yabmtxt{'9'}: $file</b></font></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2>
    <b>$yabmtxt{'10'}:</b> $modid<br>
    <b>$yabmtxt{'11'}:</b> $status<br>
    <b>$yabmtxt{'12'}:</b> $modversion<br>
    <b>$yabmtxt{'13'}:</b> $modauthor<br>
    <b>$yabmtxt{'14'}:</b> <a href="$modhomepage">$modhomepage</a><br>
    <b>$yabmtxt{'15'}:</b><br>$modmod
    </font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}" align=center>
    <BR><font size="2">$link<br><a href="$scripturl?action=modlist;\">$yabmtxt{'16'}</a></font><BR><BR></td>
  </tr>
</table>
~;

  $yytitle = "$yabmtxt{'9'}: $file";
  &template;
  exit;
}
####apply
sub applymod {
  &is_admin;
  
  eval { use File::Copy;};
  if ($@) { &fatal_error("File::Copy Perl Package not found!"); }
  sub moderror ($);
  my $file=$INFO{'file'};
  my $step=0;
  my @alteredfiles;   
  my @params=('edit file','replace','search for','add after','add before');
  
  if(fopen(FILE,"$boarddir/install.log")){
    @mods=<FILE>;
    fclose(FILE);
    foreach(@mods){
      s/\A$boardmodprefix\\//;
      chomp;
    }
  }
  if ($action eq "uninstallmod"){$install=0;}else{$install=1;}
  if (linepos(\@mods, $file )!=-1 && $install){
    &fatal_error("Mod file $file has already been installed!");
  }

  if (linepos(\@mods, $file )==-1 && !$install ){
    &fatal_error("Mod file $file has not been installed!");
  }
  
  $yymain= qq~
<table border=0 width="600" cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" cellpadding="4" align="center">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}">
    <font size=2 class="text1" color="$color{'titletext'}"><b>$yabmtxt{'17'}: $file</b></font></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=1>
~;  
  
  $yymain.= "Opening mod file...<br>";
  fopen(FILE, "$boarddir/Mods/$file")||&fatal_error("$txt{'23'} $boarddir/Mods/$file :: $!");
  $yymain.= "Parsing mod file...<br>";
  my $tag='';

  while(<FILE>){
    if($_=~m/\A<([^>]*)/){
      foreach(@params){
        if($_ eq $1) {
          $tag=$1;
          last;
        }
      }
    }
  
    if ($tag eq "edit file"){
      &commitchanges;
      $editfile=<FILE>;
      chomp $editfile;
      unless(-e "$boarddir/$editfile") {moderror("File $editfile not found!");  }
      $tag=<FILE>;
      unless($tag =~m"\A</edit file>") {moderror("Syntax error!");  }
      $yymain.= "Editing file $editfile<br>";
     
      fopen (IN,"$boarddir/$editfile")|| moderror("Cannot open file $editfile");
      @data=<IN>;
      fclose(IN);
      chomp @data;
      $tag='';
      next;
    }
  
    if($tag eq "search for"){
      if(!$editfile){moderror("Syntax error!");  }
      undef @searchfor;
      $step++;
      $yymain.= "Step $step<br>";
      while($line=<FILE>){
        if($line =~m"\A</search for>"){last;}
        chomp $line;
        push @searchfor,$line;  
      }
      $tag='';
      next;
    }
  
    if ($tag ne ''){
      if(!$editfile){moderror("Syntax error! No editing file specified!");  }
      if(!@searchfor){moderror("Syntax error! No search string specified!");  }
      undef @add;
      while($line=<FILE>){
        if($line =~m"\A</$tag>"){last;}
        chomp $line;
        push @add,$line;  
      }
      #do some real job here

      if($install){
        &search(\@data,\@searchfor);
        if ($tag eq "add after"){
          splice @data,$searchpos+@searchfor,0,@add;
        }elsif ($tag eq "add before"){
          splice @data,$searchpos,0,@add;
        }elsif ($tag eq "replace"){
          splice @data,$searchpos,scalar @searchfor,@add;
        }
      }else{
        if ($tag eq "add after"){
          @temp=@searchfor;
          push @temp,@add;
          &search(\@data,\@temp);          
          splice @data,$searchpos+@searchfor,scalar @add;
        }elsif ($tag eq "add before"){
          @temp=@searchfor;
          unshift @temp,@add;
          &search(\@data,\@temp); 
          splice @data,$searchpos,scalar @add;
        }elsif ($tag eq "replace"){
          &search(\@data,\@add);
          splice @data,$searchpos,scalar @add,@searchfor;
        }      
        undef @temp;
      }
      $yymain.= "Step complete...<br>";
      undef @searchfor;
      $tag='';
      next;                   
    }
  }      
  fclose(FILE);
  &commitchanges;
  if($install){
    push @mods,$file;
  } else{
    splice @mods,linepos(\@mods, $file ),1;
  }
  fopen (IN,">$boarddir/install.log",1)|| moderror("Cannot open file install.log");
  foreach(@mods){
    chomp;
    print IN "$boardmodprefix\\$_\n";
  }
  fclose (IN);  
  
  $yymain.=qq~
    All Done!</font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}" align=center>
    <BR><a href="$scripturl?action=modlist;\">$yabmtxt{'16'}</a></font><BR><BR></td>
  </tr>
</table>~;
  $yytitle = "$yabmtxt{'17'}: $file";
  &template;
  exit;

  sub search{
        $searchpos=arraypos($_[0],$_[1]);
        $searchpos==-1 && moderror"Search string not found!";
        $yymain.= "Search string found at line $searchpos<br>";    
  }
  
  sub commitchanges{
    if($editfile){
      $yymain.= "Backing up $editfile to $editfile.bak...<br>";
      copy "$boarddir/$editfile","$boarddir/$editfile.bak";
      $yymain.= "Saving $editfile...<br>";            
      fopen (IN,">$boarddir/$editfile")|| moderror("Cannot open file $editfile");
      my $set=0;
      foreach(@data){
        if($set){print IN "\n";}
        $set=1;
        print IN;
      }
      fclose (IN);
      push @alteredfiles,$editfile;
    }
  }
  
  sub moderror($){
    my $err=shift;
    
    foreach(@alteredfiles){
      copy "$boarddir/$_.bak","$boarddir/$_";
    }
    $yymain.=qq~
    $yabmtxt{'18'}: $err</font></td>
  </tr>
</table>~;
    $yytitle = "$yabmtxt{'17'}: $file - $yabmtxt{'18'}!";
    &template;
    exit;
  }
}

sub linepos{
  my($tar,$sub)=@_;
  my @ar=@{$tar};
  my $car=scalar @ar;
  
  for(my $i=0;$i<$car;$i++){
    if($ar[$i] eq $sub){
      return $i;
    }
  }
  return -1;
}

sub arraypos{
  my($tar,$tsub)=@_;
  my @sub=@{$tsub};
  my $csub=scalar @sub;
  my $s=linepos($tar,$sub[0]);
  return -1 if $s==-1;
  for(my $i=1;$i<$csub;$i++){
    return -1 unless $tar->[$i+$s] eq $sub[$i];
  }
  return $s;
}

1;
